import 'dart:async';

import 'package:shared_preferences/shared_preferences.dart';

const String _storageKey = "ApplicationIdOfDevice_";

Future<SharedPreferences> _prefs = SharedPreferences.getInstance();

DeviceIdPreferences deviceIdPreferences = DeviceIdPreferences();

class DeviceIdPreferences {
  /// ----------------------------------------------------------
  /// Generic routine to fetch a preference
  /// ----------------------------------------------------------
  Future<String> _getStringApplicationSavedInformation(String name) async {
    final SharedPreferences prefs = await _prefs;
    return prefs.getString(_storageKey + name) ?? '';
  }

  Future<bool> _setStringApplicationSavedInformation(
      String name, String value) async {
    final SharedPreferences prefs = await _prefs;

    return prefs.setString(_storageKey + name, value);
  }

  Future<String> getPreferredDeviceID() async {
    return _getStringApplicationSavedInformation('deviceid');
  }

  Future<bool> setPreferredDeviceID(String deviceId) async {
    return _setStringApplicationSavedInformation('deviceid', deviceId);
  }

  Future<String> getPreferredDeviceIDWeb() async {
    return _getStringApplicationSavedInformation('deviceid_web');
  }

  Future<bool> setPreferredDeviceIDWeb(String deviceId) async {
    return _setStringApplicationSavedInformation('deviceid_web', deviceId);
  }

  // ------------------ SINGLETON -----------------------
  static final DeviceIdPreferences _preferences =
      DeviceIdPreferences._internal();

  factory DeviceIdPreferences() {
    return _preferences;
  }

  DeviceIdPreferences._internal();
}
